.486p
.model flat,stdcall
option casemap:none
option proc:private

include		<windows.inc>
include		<macros.inc>
incAPI		<kernel32>,<user32>,<ole32>

ASSUME FS:NOTHING ; so we can do SEH stuff without masm b0rking

; note that bigmem.nas will have to be changed if you change MEMSIZE.
MEMSIZE TEXTEQU <1024*1024*256>


;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; DATA? section
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
.data?
buffer		BYTE	256 dup (?)
time		DWORD	?
typestring	DWORD	?
EXTERNDEF staticbuf:byte

;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; DATA section
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
.data
format		BYTE	"Ticks: %08d", 0


;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; CODE section
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
.code

ENTRY32:
	; uncomment *one* of the following lines
;	call	vsetup		; VirtualAlloc memory allocation
;	call	hsetup		; heap memory allocation
;	call	msetup		; MMF memory allocation
;	call	ssetup		; static memory "allocation"
;	call	calloc		; CoTaskMemAlloc allocation
;	call	galloc		; GlobalAlloc allocation
	mov		esi, eax	; save pointer for later use

IF 0
	; code to show where the various memory allocations go.
	invoke	wsprintf, offset buffer, CTEXT("%08X"), esi
	invoke	MessageBox, NULL, offset buffer, CTEXT("Pointer value"), MB_OK
ENDIF

	; adjust process priority
	invoke	GetCurrentProcess
	invoke	SetPriorityClass, eax, REALTIME_PRIORITY_CLASS
	invoke	GetCurrentThread
	invoke	SetThreadPriority, eax, THREAD_PRIORITY_TIME_CRITICAL
	; revoke rest of timeslice to get a bit more accurate results
	invoke	Sleep, 0

	; time touching every 4096th byte.
	invoke	GetTickCount
	mov		[time], eax
	mov		ecx, MEMSIZE / 4096
@@touchloop:
	mov		[esi], al
	add		esi, 4096
	dec		ecx
	jnz		@@touchloop
	
	invoke	GetTickCount
	sub		eax, [time]

	invoke	wsprintf, offset buffer, offset format, eax
	invoke	MessageBox, NULL, offset buffer, [typestring], MB_OK

	invoke	ExitProcess, 0

;
; procs for the various allocation types.
;
vsetup:
	mov		[typestring], CTEXT("VirtualAlloc allocation")
	invoke	VirtualAlloc, NULL, MEMSIZE, MEM_COMMIT, PAGE_READWRITE
	ret

hsetup:
	mov		[typestring], CTEXT("HeapAlloc allocation")
	invoke	GetProcessHeap
	invoke	HeapAlloc, eax, HEAP_ZERO_MEMORY, MEMSIZE
	ret

msetup:
	mov		[typestring], CTEXT("filemapping allocation")
	invoke	CreateFileMapping, INVALID_HANDLE_VALUE, NULL, PAGE_READWRITE, NULL, MEMSIZE, NULL
	invoke	MapViewOfFile, eax, FILE_MAP_ALL_ACCESS, 0, 0, MEMSIZE
	ret

ssetup:
	mov		[typestring], CTEXT("static allocation")
	mov		eax, offset staticbuf
	ret

calloc:
	mov		[typestring], CTEXT("CoTaskMemAlloc allocation")
	invoke	CoTaskMemAlloc, MEMSIZE
	ret

galloc:
	mov		[typestring], CTEXT("GlobalAlloc allocation")
	invoke	GlobalAlloc, GMEM_ZEROINIT, MEMSIZE
	; no, we do not need GlobalLock on win32 - a direct memory pointer is returned.
	; I'm not going to go into details as to why, but it has to do with win32's
	; method of handling physical memory (paging) as opposed to win16's floating
	; memory stuff.
	ret

END ENTRY32
